=== debian/changelog ===
asymptote (2.84+ds-1) unstable; urgency=medium

  New upstream version.
  * Contains fix for "xasy crashed when clicking on the grid button"
    (Closes: #1023920).

  [ Debian Janitor ]
  * Use secure URI in Homepage field.
  * Update standards version to 4.6.1, no changes needed.

  [ Hilmar Preusse ]
  * Replace BD on freeglut3-dev by libglut-dev.
  * Bump Standards Version, no changes needed.

 -- Hilmar Preusse <hille42@web.de>  Fri, 27 Jan 2023 13:01:08 +0100
