=== cudareflect/tinyexr/experimental/js/Makefile ===
all:
	./compile_to_js.sh
