=== debian/changelog ===
asymptote (2.85+ds-1) unstable; urgency=medium

  * New upstream version.

 -- Hilmar Preusse <hille42@web.de>  Fri, 10 Feb 2023 10:27:35 +0100

asymptote (2.84+ds-2) unstable; urgency=medium

  * Don't specify boost version in B-D and in dep of test suite to
    make boost transition possible.
  * Lintian: W: executable-not-elf-or-script

 -- Hilmar Preusse <hille42@web.de>  Sun, 29 Jan 2023 20:29:34 +0100
