=== debian/control ===
--- 
+++ 
@@ -17,9 +17,9 @@
                libosmesa6-dev,
                ghostscript,
                imagemagick,
-               libboost-program-options1.74-dev,
-               libboost-filesystem1.74-dev,
-               libboost-thread1.74-dev,
+               libboost-program-options-dev,
+               libboost-filesystem-dev,
+               libboost-thread-dev,
                libcurl4-gnutls-dev,
                libeigen3-dev,
                libfftw3-dev,
